(function(){
    /**
     * @file MotionBoard plugin item: Digital clock
     * @copyright WingArc1st Inc.
     * @version 0.7.0
     * @license This plug-in is provided by [MIT license]{@link https://opensource.org/licenses/mit-license.php}
     */
    (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
    (function (global){
    // Do not change from here
    function PluginObject(canvasId)
    {
        this.canvasId = canvasId;
    
        this.x = 0;
        this.y = 0;
        this.width = 0;
        this.height = 0;
    
        this.drillDown = null;
        this.drillUp = null;
        this.drillThrough = null;
        this.relation = null;
        this.dataPointAction = null;
    
        this.invalidateDisplayList = null;
        this.callLater = null;
    }
    
    PluginObject.prototype = {};
    PluginObject.prototype.constructor = PluginObject;
    module.exports = PluginObject;
    
    PluginObject.prototype.createChildren = function ()
    {
    }
    
    PluginObject.prototype.updateDisplayList = function (width, height)
    {
    }
    
    PluginObject.prototype.setConfig = function (config)
    {
    }
    
    PluginObject.prototype.setData = function (data, type)
    {
    }
    
    PluginObject.prototype.onMove = function (x, y)
    {
        this.x = x;
        this.y = y;
    }
    
    PluginObject.prototype.onResize = function (width, height)
    {
        this.width = width;
        this.height = height;
    }
    
    PluginObject.prototype.onMouseEvent = function (event)
    {
    }
    
    PluginObject.prototype.onKeyboardEvent = function (event)
    {
    }
    
    PluginObject.prototype.destroy = function ()
    {
    }
    
    if (!global.JSPLUGIN) {
        global.JSPLUGIN = {};
    }
    // Do not change up to here
    }).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
    },{}],2:[function(require,module,exports){
    (function (global){
    var PluginObject = require('./PluginObject');
    /**help
     * Please write the help text of this plugin here.
     */
    // Please write your program here.
    
    /**
     * Constructor of the digital clock
     * @memberof DigitalClock
     * @method DigitalClock
     * @param {String} canvasId
     */
    function DigitalClock(canvasId)
    {
        PluginObject.call(this, canvasId);
    
        /** For canvas element storage
         * @type {Element}
         * @memberof DigitalClock
         */
        this.canvas = document.getElementById(canvasId);
        /** For 2D drawing object storage
         * @type {CanvasRenderingContext2D}
         * @memberof DigitalClock
         */
        this.context2d = this.canvas.getContext('2d');
        /** Timer ID for clock display update
         * @type {Number}
         * @memberof DigitalClock
         */
        this.timer = null;
        /** Error message. Null indicates no error
         * @type {String}
         * @memberof DigitalClock
         */
        this.error_message = null;
        /** Setting items for this plugin
         * @type {Object}
         * @property {String} format - Time display format(e.g.： "hh:mm:ss")
         * 		YYYY : Year
         * 		MM : Month(two-digit。If only one M is used, a single digit is displayed if the tenth place is 0)
         * 		DD : Day(two-digit。If only one D is used, a single digit is displayed if the tenth place is 0)
         * 		hh : Hour(two-digit。If only one h is used, a single digit is displayed if the tenth place is 0)
         * 		mm : Minute(two-digit。If only one m is used, a single digit is displayed if the tenth place is 0)
         * 		ss : Second(two-digit。If only one s is used, a single digit is displayed if the tenth place is 0)
         * @property {String} digit_color
         *  Can be specified in [CSS color]{@link https://developer.mozilla.org/ja/docs/Web/CSS/color_value}
         * @property {String} font_size - Font size of the text to be displayed within the button.
         * @property {String} font_family - Font family of the text to be displayed within the button.
         *  Can be specified in [Font family]{@link https://w3g.jp/sample/css/font-family}
		 *  If 7seg is specified, it is drawn in 7-segment style font.
         * @memberof DigitalClock
         */	
        this.config = {
            format: "hh:mm:ss",
            digit_color: "teal",
            font_size: 20,
            font_family: "sans-serif"
        };
    }
    
    // Do not change from here.
    DigitalClock.prototype = Object.create(PluginObject.prototype);
    DigitalClock.prototype.constructor = DigitalClock;
    module.exports = DigitalClock;
    // Do not change up to here.
    
    /**
     * Method called by MotionBoard when a plug-in item is added to the stage
     * @memberof DigitalClock
     * @method createChildren
     */
    DigitalClock.prototype.createChildren = function ()
    {
        PluginObject.prototype.createChildren.call(this);
        
        if(this.timer === null) {
            this.timer = setInterval(this.invalidateDisplayList.bind(this), 1000);
        }	
    }
    
    /**
     * Method called by MotionBoard when a plugin item is destroyed
     * @memberof DigitalClock
     * @method destroy
     */
    DigitalClock.prototype.destroy = function ()
    {
        PluginObject.prototype.destroy.call(this);
        
        if(this.timer !== null) {
            clearTimeout(this.timer);
            this.timer = null;
        }
    }
    
    /**
     * @param {String}	ch		One character to be drawn
     * @param {Number}	x		Left position to start drawing text
     * @param {Number}	y		Top position to start drawing text
     * @param {float}	width	Width of text drawing area
     * @param {float}	height	Height of text drawing area
     * @return true: Drawing is performed. false:The character cannot be drawn
     * @memberof DigitalClock
     * @method updateDisplayList
     */
    DigitalClock.prototype.drawCharacter = function (ch, x, y, width, height)
    {
        const ctx = this.context2d;
        let isDrawn = false;

        // Coordinates of hexagonal vertices
        let arrayHexagon = [
            [ [ 3,  4], [ 5,  2], [15,  2], [17,  4], [15,  6], [ 5,  6] ], // Landscape(Top)
            [ [ 2,  5], [ 0,  7], [ 0, 17], [ 2, 19], [ 4, 17], [ 4,  7] ], // Portrait(Upper left)
            [ [ 18, 5], [16,  7], [16, 17], [18, 19], [20, 17], [20,  7] ], // Portrait(Upper right)
            [ [ 3, 20], [ 5, 18], [15, 18], [17, 20], [15, 22], [ 5, 22] ], // Landscape(Center)
            [ [ 2, 21], [ 0, 23], [ 0, 33], [ 2, 35], [ 4, 33], [ 4, 23] ], // Portrait(Lower left)
            [ [18, 21], [16, 23], [16, 33], [18, 35], [20, 33], [20, 23] ], // Portrait(Lower right)
            [ [ 3, 36], [ 5, 34], [15, 34], [17, 36], [15, 38], [ 5, 38] ]  // Landscape(Bottom)
        ];
    
        // ON(=1)/OFF(=0) information for each hexagon comprising a number(0-9)
        // Order: [Landscape(Top), Portrait(Upper left), Portrait(Upper right), Landscape(Center), Portrait(Lower left),Portrait(Lower right), Landscape(Bottom)]
        let arrayOnOff = [
            [ 1, 1, 1, 0, 1, 1, 1 ], // 0
            [ 0, 0, 1, 0, 0, 1, 0 ], // 1
            [ 1, 0, 1, 1, 1, 0, 1 ], // 2
            [ 1, 0, 1, 1, 0, 1, 1 ], // 3
            [ 0, 1, 1, 1, 0, 1, 0 ], // 4
            [ 1, 1, 0, 1, 0, 1, 1 ], // 5
            [ 1, 1, 0, 1, 1, 1, 1 ], // 6
            [ 1, 0, 1, 0, 0, 1, 0 ], // 7
            [ 1, 1, 1, 1, 1, 1, 1 ], // 8
            [ 1, 1, 1, 1, 0, 1, 1 ]  // 9  
        ];

        // List of strings that can be drawn with "7seg"
        let drawch = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ":", "/"];

        // List of numbers ("0"-"9")
        let drawch_num = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"];

        if( drawch.includes(ch) ) {
            if( drawch_num.includes(ch) ) {
                // Numeric ("0"-"9") drawing process
                for (let i = 0; i < arrayHexagon.length; i++) {
                    ctx.beginPath();
                    for (let j = 0; j < arrayHexagon[i].length; j++) {
                        if ( j == 0) {
                            ctx.moveTo(x + arrayHexagon[i][j][0] * (width/20), y + arrayHexagon[i][j][1] * (height/40) );
                        } else {
                            ctx.lineTo(x + arrayHexagon[i][j][0] * (width/20), y + arrayHexagon[i][j][1] * (height/40) );
                        }
                    }
                    if (arrayOnOff[ch][i] == 1) {
                        ctx.globalAlpha = 1;
                    } else {
                        ctx.globalAlpha = 0.1;
                    }
                    ctx.fill();
                }
                isDrawn = true;
            } else if ( ch == ":") {
                // Colon (":") drawing process
                ctx.beginPath();
                ctx.globalAlpha = 1;
                ctx.moveTo(x +  8 * (width/20), y + 10 * (height/40) );
                ctx.lineTo(x + 12 * (width/20), y + 10 * (height/40) );
                ctx.lineTo(x + 12 * (width/20), y + 14 * (height/40) );
                ctx.lineTo(x +  8 * (width/20), y + 14 * (height/40) );
                ctx.fill();
                ctx.moveTo(x +  8 * (width/20), y + 26 * (height/40) );
                ctx.lineTo(x + 12 * (width/20), y + 26 * (height/40) );
                ctx.lineTo(x + 12 * (width/20), y + 30 * (height/40) );
                ctx.lineTo(x +  8 * (width/20), y + 30 * (height/40) );
                ctx.fill();
                isDrawn = true;
            } else if ( ch == "/" ) {
                // Slash ("/") drawing process
                ctx.beginPath();
                ctx.globalAlpha = 1;
                ctx.moveTo(x + 16 * (width/20), y +  2 * (height/40) );
                ctx.lineTo(x + 20 * (width/20), y +  2 * (height/40) );
                ctx.lineTo(x +  4 * (width/20), y + 38 * (height/40) );
                ctx.lineTo(x +  0 * (width/20), y + 38 * (height/40) );
                ctx.fill();
                isDrawn = true;
            }
        } else {
            isDrawn = false;
        }

		ctx.globalAlpha = 1;
        return isDrawn;
    }

    /**
     * Method called by MotionBoard when drawing chart
     * @param {float}	width	Width of the plugin's drawing area
     * @param {float}	height	Height of the plugin's drawing area
     * @memberof DigitalClock
     * @method updateDisplayList
     */
    DigitalClock.prototype.updateDisplayList = function (width, height)
    {
        if(this.error_message !== null) {
            this.drawErrorMessage(width, height);
        }
        
        const ctx = this.context2d;
        const date = new Date();
        let str = this.config.format;
        
        // assemble clock string
        str = str.replace(/YYYY/, date.getFullYear());
        str = str.replace(/MM/, ("00" + (date.getMonth() + 1)).slice(-2));
        str = str.replace(/M/, date.getMonth() + 1);
        str = str.replace(/DD/, ("00" + date.getDate()).slice(-2));
        str = str.replace(/D/, date.getDate());
        str = str.replace(/hh/, ("00" + date.getHours()).slice(-2));
        str = str.replace(/h/, date.getHours());
        str = str.replace(/mm/, ("00" + date.getMinutes()).slice(-2));
        str = str.replace(/m/, date.getMinutes());
        str = str.replace(/ss/, ("00" + date.getSeconds()).slice(-2));
        str = str.replace(/s/, date.getSeconds());
        
        // draw digital clock
        ctx.clearRect(0, 0, width, height);
        ctx.fillStyle = this.config.digit_color;
        ctx.textBaseline = "middle";
        if(this.config.font_family == "7seg") {
            ctx.font = String(this.config.font_size) + "px sans-serif";
            let x = 0;
            const y = height / 2 - this.config.font_size / 2;
            const ch_width = this.config.font_size / 2;
            const ch_height = this.config.font_size;
            for(let i = 0; i < str.length; i++) {
                if(x >= width) {
                    break;
                }
                let isDrawn = false;
                isDrawn = this.drawCharacter(str.charAt(i), x, y, ch_width, ch_height);
                if(isDrawn) {
                    x += ch_width + 4;
                } else {
                    ctx.fillText(str.charAt(i), x, height / 2);

                    x += ctx.measureText(str.charAt(i)).width + 1;
                }
            }
        } else {
            ctx.font = String(this.config.font_size) + "px " + this.config.font_family;
            ctx.fillText(str, 0, height / 2);
        }
    }
    
    /**
     * Method called by MotionBoard when a plugin item's text string is set or modified.
     * @param {String}	config	Text string. Specify in the following JSON format string<br>
     * <ul>
     * <li> format: Date display format (eg： "hh:mm:ss")
     *  <ul>
     * 		<li> YYYY : Year
     * 		<li> MM : Month(two-digit。If only one M is used, a single digit is displayed if the tenth place is 0)
     * 		<li> DD : Day(two-digit。If only one D is used, a single digit is displayed if the tenth place is 0)
     * 		<li> hh : Hour(two-digit。If only one h is used, a single digit is displayed if the tenth place is 0)
     * 		<li> mm : Minute(two-digit。If only one m is used, a single digit is displayed if the tenth place is 0)
     * 		<li> ss : Second(two-digit。If only one s is used, a single digit is displayed if the tenth place is 0)
     *  </ul>
     * <li> digit_color : Text color
     *  Can be specified in [CSS color]{@link https://developer.mozilla.org/ja/docs/Web/CSS/color_value}
     *  e.g.："rgb(255,0,0)", "red", "#FF0000"
     * <li> font_size : Font size of the text to be displayed in the button.
     * <li> font_family : Font family of the text to be displayed in the button.
     *  Can be specified in [Font family]{@link https://w3g.jp/sample/css/font-family}
	 *  If 7seg is specified, it is drawn in 7-segment style font.
     * </ul>
     * Example : 
     * {
     *   "format": "hh:mm:ss",
     *   "digit_color": "white",
     *   "font_size": 20,
     *   "font_family": "Meiryo"
     * }
     * @memberof DigitalClock
     * @method setConfig
     */
    DigitalClock.prototype.setConfig = function (config)
    {
        if((config === null) || (config.length === 0)) {
            return;
        }
        
        try {
            const cfg = JSON.parse(config);
            if("format" in cfg) {
                this.config.format = cfg.format;
            }
            if("digit_color" in cfg) {
                this.config.digit_color = cfg.digit_color;
            }
            if("font_size" in cfg) {
                this.config.font_size = cfg.font_size;
            }
            if("font_family" in cfg) {
                this.config.font_family = cfg.font_family;
            }
            this.error_message = null;
        } catch (err){
            this.error_message = "Invalid setting vallue. " + err;
        }
    }
    
    /**
     * Drawing error message
     * @param {float}	width	Width of the plugin's drawing area
     * @param {float}	height	Height of the plugin's drawing area
     * @memberof DigitalClock
     * @method drawErrorMessage
     */
    DigitalClock.prototype.drawErrorMessage = function (width, height)
    {
        let context = this.context2d;
        const message = "ERROR : " + this.error_message;
    
        context.fillStyle = "white";
        context.fillRect(0, 0, width, height);
        context.fillStyle = "red";
        context.textBaseline = "top";
        context.font = "20px 'MS PGothic', san-serif";
        let w = 0;
        let len = message.length;
        let line = message.charAt(0);
        let y = 0;
        for(let i = 1; i < len; i++) {
            let c = message.charAt(i);
            let textSize = context.measureText(line + c);
            if(textSize.width < width) {
                line += c;
            } else {
                context.fillText(line, 0, y);
                y += textSize.actualBoundingBoxAscent + textSize.actualBoundingBoxDescent + 1;
                line = c;
            }
        }
        if(line.length > 0) {
            context.fillText(line, 0, y);
        }
    }
    
    // Please write your program up to here.
    
    global.JSPLUGIN.DigitalClock = {
        _class_:DigitalClock
    };
    
    }).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
    },{"./PluginObject":1}]},{},[2]);
    
    }());